--- src/Thumbview.h	Wed Oct 14 14:46:35 2009
+++ src/Thumbview.h	Sun Aug 15 20:12:49 2010
@@ -142,10 +142,25 @@
 
         DisplayMode m_curmode; 
 
-        void set_current_display_mode(DisplayMode newmode);
+        void set_current_display_mode(DisplayMode newmode) {
+			remove();
+			if (newmode == LIST)
+				add(view);
+			else if (newmode == ICON)
+				add(iview);
+
+			m_curmode = newmode;
+			show_all();
+		}
         DisplayMode get_current_display_mode() { return m_curmode; }
 
-        void set_icon_captions(gboolean caps);
+        void set_icon_captions(gboolean caps) {
+		    m_icon_captions = caps;
+		    if (m_icon_captions)
+		        iview.set_markup_column(record.Description);
+		    else
+		        iview.set_markup_column(-1);  // -1 unsets
+		}
         gboolean get_icon_captions() { return m_icon_captions; }
 
         Gtk::TreeModel::iterator get_selected();
@@ -161,8 +176,8 @@
         void update_last_loaded_time()
             { m_last_loaded_time.assign_current_time(); }
 
-        void sighandle_iview_activated(const Gtk::TreePath& path);
-        void sighandle_view_activated(const Gtk::TreePath& path, Gtk::TreeViewColumn *column);
+        void sighandle_iview_activated(const Gtk::TreePath& path) { signal_selected(path); }
+        void sighandle_view_activated(const Gtk::TreePath& path, Gtk::TreeViewColumn *column) { signal_selected(path); }
 
 #ifdef USE_INOTIFY
 		void file_deleted_callback(std::string filename);
